// Code generated by girgen. DO NOT EDIT.

package gdk

import (
	"runtime"
	"unsafe"

	"github.com/diamondburned/gotk4/pkg/core/gextras"
	externglib "github.com/diamondburned/gotk4/pkg/core/glib"
	"github.com/diamondburned/gotk4/pkg/glib/v2"
)

// #include <stdlib.h>
// #include <gdk/gdk.h>
// #include <glib-object.h>
import "C"

// NewContentProviderForBytes: create a content provider that provides the given
// bytes as data for the given mime_type.
//
// The function takes the following parameters:
//
//    - mimeType: mime type.
//    - bytes: GBytes with the data for mime_type.
//
// The function returns the following values:
//
//    - contentProvider: new GdkContentProvider.
//
func NewContentProviderForBytes(mimeType string, bytes *glib.Bytes) *ContentProvider {
	var _arg1 *C.char               // out
	var _arg2 *C.GBytes             // out
	var _cret *C.GdkContentProvider // in

	_arg1 = (*C.char)(unsafe.Pointer(C.CString(mimeType)))
	defer C.free(unsafe.Pointer(_arg1))
	_arg2 = (*C.GBytes)(gextras.StructNative(unsafe.Pointer(bytes)))

	_cret = C.gdk_content_provider_new_for_bytes(_arg1, _arg2)
	runtime.KeepAlive(mimeType)
	runtime.KeepAlive(bytes)

	var _contentProvider *ContentProvider // out

	_contentProvider = wrapContentProvider(externglib.AssumeOwnership(unsafe.Pointer(_cret)))

	return _contentProvider
}

// NewContentProviderForValue: create a content provider that provides the given
// value.
//
// The function takes the following parameters:
//
//    - value: GValue.
//
// The function returns the following values:
//
//    - contentProvider: new GdkContentProvider.
//
func NewContentProviderForValue(value *externglib.Value) *ContentProvider {
	var _arg1 *C.GValue             // out
	var _cret *C.GdkContentProvider // in

	_arg1 = (*C.GValue)(unsafe.Pointer(value.Native()))

	_cret = C.gdk_content_provider_new_for_value(_arg1)
	runtime.KeepAlive(value)

	var _contentProvider *ContentProvider // out

	_contentProvider = wrapContentProvider(externglib.AssumeOwnership(unsafe.Pointer(_cret)))

	return _contentProvider
}

// NewContentProviderUnion creates a content provider that represents all the
// given providers.
//
// Whenever data needs to be written, the union provider will try the given
// providers in the given order and the first one supporting a format will be
// chosen to provide it.
//
// This allows an easy way to support providing data in different formats. For
// example, an image may be provided by its file and by the image contents with
// a call such as
//
//    gdk_content_provider_new_union ((GdkContentProvider *[2]) {
//                                      gdk_content_provider_new_typed (G_TYPE_FILE, file),
//                                      gdk_content_provider_new_typed (G_TYPE_TEXTURE, texture)
//                                    }, 2);.
//
// The function takes the following parameters:
//
//    - providers (optional): The ContentProviders to present the union of.
//
// The function returns the following values:
//
//    - contentProvider: new GdkContentProvider.
//
func NewContentProviderUnion(providers []*ContentProvider) *ContentProvider {
	var _arg1 **C.GdkContentProvider // out
	var _arg2 C.gsize
	var _cret *C.GdkContentProvider // in

	if providers != nil {
		_arg2 = (C.gsize)(len(providers))
		_arg1 = (**C.GdkContentProvider)(C.calloc(C.size_t(len(providers)), C.size_t(unsafe.Sizeof(uint(0)))))
		{
			out := unsafe.Slice((**C.GdkContentProvider)(_arg1), len(providers))
			for i := range providers {
				out[i] = (*C.GdkContentProvider)(unsafe.Pointer(externglib.InternObject(providers[i]).Native()))
				C.g_object_ref(C.gpointer(externglib.InternObject(providers[i]).Native()))
			}
		}
	}

	_cret = C.gdk_content_provider_new_union(_arg1, _arg2)
	runtime.KeepAlive(providers)

	var _contentProvider *ContentProvider // out

	_contentProvider = wrapContentProvider(externglib.AssumeOwnership(unsafe.Pointer(_cret)))

	return _contentProvider
}
