// Code generated by girgen. DO NOT EDIT.

package gio

import (
	"runtime"
	"unsafe"

	"github.com/diamondburned/gotk4/pkg/core/gbox"
	externglib "github.com/diamondburned/gotk4/pkg/core/glib"
)

// #include <stdlib.h>
// #include <gio/gio.h>
// #include <glib-object.h>
// extern gchar* _gotk4_gio2_InetAddressClass_to_string(GInetAddress*);
import "C"

// glib.Type values for ginetaddress.go.
var GTypeInetAddress = externglib.Type(C.g_inet_address_get_type())

func init() {
	externglib.RegisterGValueMarshalers([]externglib.TypeMarshaler{
		{T: GTypeInetAddress, F: marshalInetAddress},
	})
}

// InetAddressOverrider contains methods that are overridable.
type InetAddressOverrider interface {
	// String converts address to string form.
	//
	// The function returns the following values:
	//
	//    - utf8: representation of address as a string, which should be freed
	//      after use.
	//
	String() string
}

// InetAddress represents an IPv4 or IPv6 internet address. Use
// g_resolver_lookup_by_name() or g_resolver_lookup_by_name_async() to look up
// the Address for a hostname. Use g_resolver_lookup_by_address() or
// g_resolver_lookup_by_address_async() to look up the hostname for a Address.
//
// To actually connect to a remote host, you will need a SocketAddress (which
// includes a Address as well as a port number).
type InetAddress struct {
	_ [0]func() // equal guard
	*externglib.Object
}

var (
	_ externglib.Objector = (*InetAddress)(nil)
)

func classInitInetAddresser(gclassPtr, data C.gpointer) {
	C.g_type_class_add_private(gclassPtr, C.gsize(unsafe.Sizeof(uintptr(0))))

	goffset := C.g_type_class_get_instance_private_offset(gclassPtr)
	*(*C.gpointer)(unsafe.Add(unsafe.Pointer(gclassPtr), goffset)) = data

	goval := gbox.Get(uintptr(data))
	pclass := (*C.GInetAddressClass)(unsafe.Pointer(gclassPtr))
	// gclass := (*C.GTypeClass)(unsafe.Pointer(gclassPtr))
	// pclass := (*C.GInetAddressClass)(unsafe.Pointer(C.g_type_class_peek_parent(gclass)))

	if _, ok := goval.(interface{ String() string }); ok {
		pclass.to_string = (*[0]byte)(C._gotk4_gio2_InetAddressClass_to_string)
	}
}

//export _gotk4_gio2_InetAddressClass_to_string
func _gotk4_gio2_InetAddressClass_to_string(arg0 *C.GInetAddress) (cret *C.gchar) {
	goval := externglib.GoPrivateFromObject(unsafe.Pointer(arg0))
	iface := goval.(interface{ String() string })

	utf8 := iface.String()

	cret = (*C.gchar)(unsafe.Pointer(C.CString(utf8)))

	return cret
}

func wrapInetAddress(obj *externglib.Object) *InetAddress {
	return &InetAddress{
		Object: obj,
	}
}

func marshalInetAddress(p uintptr) (interface{}, error) {
	return wrapInetAddress(externglib.ValueFromNative(unsafe.Pointer(p)).Object()), nil
}

// NewInetAddressAny creates a Address for the "any" address (unassigned/"don't
// care") for family.
//
// The function takes the following parameters:
//
//    - family address family.
//
// The function returns the following values:
//
//    - inetAddress: new Address corresponding to the "any" address for family.
//      Free the returned object with g_object_unref().
//
func NewInetAddressAny(family SocketFamily) *InetAddress {
	var _arg1 C.GSocketFamily // out
	var _cret *C.GInetAddress // in

	_arg1 = C.GSocketFamily(family)

	_cret = C.g_inet_address_new_any(_arg1)
	runtime.KeepAlive(family)

	var _inetAddress *InetAddress // out

	_inetAddress = wrapInetAddress(externglib.AssumeOwnership(unsafe.Pointer(_cret)))

	return _inetAddress
}

// NewInetAddressFromString parses string as an IP address and creates a new
// Address.
//
// The function takes the following parameters:
//
//    - str: string representation of an IP address.
//
// The function returns the following values:
//
//    - inetAddress (optional): new Address corresponding to string, or NULL if
//      string could not be parsed. Free the returned object with
//      g_object_unref().
//
func NewInetAddressFromString(str string) *InetAddress {
	var _arg1 *C.gchar        // out
	var _cret *C.GInetAddress // in

	_arg1 = (*C.gchar)(unsafe.Pointer(C.CString(str)))
	defer C.free(unsafe.Pointer(_arg1))

	_cret = C.g_inet_address_new_from_string(_arg1)
	runtime.KeepAlive(str)

	var _inetAddress *InetAddress // out

	if _cret != nil {
		_inetAddress = wrapInetAddress(externglib.AssumeOwnership(unsafe.Pointer(_cret)))
	}

	return _inetAddress
}

// NewInetAddressLoopback creates a Address for the loopback address for family.
//
// The function takes the following parameters:
//
//    - family address family.
//
// The function returns the following values:
//
//    - inetAddress: new Address corresponding to the loopback address for
//      family. Free the returned object with g_object_unref().
//
func NewInetAddressLoopback(family SocketFamily) *InetAddress {
	var _arg1 C.GSocketFamily // out
	var _cret *C.GInetAddress // in

	_arg1 = C.GSocketFamily(family)

	_cret = C.g_inet_address_new_loopback(_arg1)
	runtime.KeepAlive(family)

	var _inetAddress *InetAddress // out

	_inetAddress = wrapInetAddress(externglib.AssumeOwnership(unsafe.Pointer(_cret)))

	return _inetAddress
}

// Equal checks if two Address instances are equal, e.g. the same address.
//
// The function takes the following parameters:
//
//    - otherAddress: another Address.
//
// The function returns the following values:
//
//    - ok: TRUE if address and other_address are equal, FALSE otherwise.
//
func (address *InetAddress) Equal(otherAddress *InetAddress) bool {
	var _arg0 *C.GInetAddress // out
	var _arg1 *C.GInetAddress // out
	var _cret C.gboolean      // in

	_arg0 = (*C.GInetAddress)(unsafe.Pointer(externglib.InternObject(address).Native()))
	_arg1 = (*C.GInetAddress)(unsafe.Pointer(externglib.InternObject(otherAddress).Native()))

	_cret = C.g_inet_address_equal(_arg0, _arg1)
	runtime.KeepAlive(address)
	runtime.KeepAlive(otherAddress)

	var _ok bool // out

	if _cret != 0 {
		_ok = true
	}

	return _ok
}

// Family gets address's family.
//
// The function returns the following values:
//
//    - socketFamily address's family.
//
func (address *InetAddress) Family() SocketFamily {
	var _arg0 *C.GInetAddress // out
	var _cret C.GSocketFamily // in

	_arg0 = (*C.GInetAddress)(unsafe.Pointer(externglib.InternObject(address).Native()))

	_cret = C.g_inet_address_get_family(_arg0)
	runtime.KeepAlive(address)

	var _socketFamily SocketFamily // out

	_socketFamily = SocketFamily(_cret)

	return _socketFamily
}

// IsAny tests whether address is the "any" address for its family.
//
// The function returns the following values:
//
//    - ok: TRUE if address is the "any" address for its family.
//
func (address *InetAddress) IsAny() bool {
	var _arg0 *C.GInetAddress // out
	var _cret C.gboolean      // in

	_arg0 = (*C.GInetAddress)(unsafe.Pointer(externglib.InternObject(address).Native()))

	_cret = C.g_inet_address_get_is_any(_arg0)
	runtime.KeepAlive(address)

	var _ok bool // out

	if _cret != 0 {
		_ok = true
	}

	return _ok
}

// IsLinkLocal tests whether address is a link-local address (that is, if it
// identifies a host on a local network that is not connected to the Internet).
//
// The function returns the following values:
//
//    - ok: TRUE if address is a link-local address.
//
func (address *InetAddress) IsLinkLocal() bool {
	var _arg0 *C.GInetAddress // out
	var _cret C.gboolean      // in

	_arg0 = (*C.GInetAddress)(unsafe.Pointer(externglib.InternObject(address).Native()))

	_cret = C.g_inet_address_get_is_link_local(_arg0)
	runtime.KeepAlive(address)

	var _ok bool // out

	if _cret != 0 {
		_ok = true
	}

	return _ok
}

// IsLoopback tests whether address is the loopback address for its family.
//
// The function returns the following values:
//
//    - ok: TRUE if address is the loopback address for its family.
//
func (address *InetAddress) IsLoopback() bool {
	var _arg0 *C.GInetAddress // out
	var _cret C.gboolean      // in

	_arg0 = (*C.GInetAddress)(unsafe.Pointer(externglib.InternObject(address).Native()))

	_cret = C.g_inet_address_get_is_loopback(_arg0)
	runtime.KeepAlive(address)

	var _ok bool // out

	if _cret != 0 {
		_ok = true
	}

	return _ok
}

// IsMcGlobal tests whether address is a global multicast address.
//
// The function returns the following values:
//
//    - ok: TRUE if address is a global multicast address.
//
func (address *InetAddress) IsMcGlobal() bool {
	var _arg0 *C.GInetAddress // out
	var _cret C.gboolean      // in

	_arg0 = (*C.GInetAddress)(unsafe.Pointer(externglib.InternObject(address).Native()))

	_cret = C.g_inet_address_get_is_mc_global(_arg0)
	runtime.KeepAlive(address)

	var _ok bool // out

	if _cret != 0 {
		_ok = true
	}

	return _ok
}

// IsMcLinkLocal tests whether address is a link-local multicast address.
//
// The function returns the following values:
//
//    - ok: TRUE if address is a link-local multicast address.
//
func (address *InetAddress) IsMcLinkLocal() bool {
	var _arg0 *C.GInetAddress // out
	var _cret C.gboolean      // in

	_arg0 = (*C.GInetAddress)(unsafe.Pointer(externglib.InternObject(address).Native()))

	_cret = C.g_inet_address_get_is_mc_link_local(_arg0)
	runtime.KeepAlive(address)

	var _ok bool // out

	if _cret != 0 {
		_ok = true
	}

	return _ok
}

// IsMcNodeLocal tests whether address is a node-local multicast address.
//
// The function returns the following values:
//
//    - ok: TRUE if address is a node-local multicast address.
//
func (address *InetAddress) IsMcNodeLocal() bool {
	var _arg0 *C.GInetAddress // out
	var _cret C.gboolean      // in

	_arg0 = (*C.GInetAddress)(unsafe.Pointer(externglib.InternObject(address).Native()))

	_cret = C.g_inet_address_get_is_mc_node_local(_arg0)
	runtime.KeepAlive(address)

	var _ok bool // out

	if _cret != 0 {
		_ok = true
	}

	return _ok
}

// IsMcOrgLocal tests whether address is an organization-local multicast
// address.
//
// The function returns the following values:
//
//    - ok: TRUE if address is an organization-local multicast address.
//
func (address *InetAddress) IsMcOrgLocal() bool {
	var _arg0 *C.GInetAddress // out
	var _cret C.gboolean      // in

	_arg0 = (*C.GInetAddress)(unsafe.Pointer(externglib.InternObject(address).Native()))

	_cret = C.g_inet_address_get_is_mc_org_local(_arg0)
	runtime.KeepAlive(address)

	var _ok bool // out

	if _cret != 0 {
		_ok = true
	}

	return _ok
}

// IsMcSiteLocal tests whether address is a site-local multicast address.
//
// The function returns the following values:
//
//    - ok: TRUE if address is a site-local multicast address.
//
func (address *InetAddress) IsMcSiteLocal() bool {
	var _arg0 *C.GInetAddress // out
	var _cret C.gboolean      // in

	_arg0 = (*C.GInetAddress)(unsafe.Pointer(externglib.InternObject(address).Native()))

	_cret = C.g_inet_address_get_is_mc_site_local(_arg0)
	runtime.KeepAlive(address)

	var _ok bool // out

	if _cret != 0 {
		_ok = true
	}

	return _ok
}

// IsMulticast tests whether address is a multicast address.
//
// The function returns the following values:
//
//    - ok: TRUE if address is a multicast address.
//
func (address *InetAddress) IsMulticast() bool {
	var _arg0 *C.GInetAddress // out
	var _cret C.gboolean      // in

	_arg0 = (*C.GInetAddress)(unsafe.Pointer(externglib.InternObject(address).Native()))

	_cret = C.g_inet_address_get_is_multicast(_arg0)
	runtime.KeepAlive(address)

	var _ok bool // out

	if _cret != 0 {
		_ok = true
	}

	return _ok
}

// IsSiteLocal tests whether address is a site-local address such as 10.0.0.1
// (that is, the address identifies a host on a local network that can not be
// reached directly from the Internet, but which may have outgoing Internet
// connectivity via a NAT or firewall).
//
// The function returns the following values:
//
//    - ok: TRUE if address is a site-local address.
//
func (address *InetAddress) IsSiteLocal() bool {
	var _arg0 *C.GInetAddress // out
	var _cret C.gboolean      // in

	_arg0 = (*C.GInetAddress)(unsafe.Pointer(externglib.InternObject(address).Native()))

	_cret = C.g_inet_address_get_is_site_local(_arg0)
	runtime.KeepAlive(address)

	var _ok bool // out

	if _cret != 0 {
		_ok = true
	}

	return _ok
}

// NativeSize gets the size of the native raw binary address for address. This
// is the size of the data that you get from g_inet_address_to_bytes().
//
// The function returns the following values:
//
//    - gsize: number of bytes used for the native version of address.
//
func (address *InetAddress) NativeSize() uint {
	var _arg0 *C.GInetAddress // out
	var _cret C.gsize         // in

	_arg0 = (*C.GInetAddress)(unsafe.Pointer(externglib.InternObject(address).Native()))

	_cret = C.g_inet_address_get_native_size(_arg0)
	runtime.KeepAlive(address)

	var _gsize uint // out

	_gsize = uint(_cret)

	return _gsize
}

// String converts address to string form.
//
// The function returns the following values:
//
//    - utf8: representation of address as a string, which should be freed after
//      use.
//
func (address *InetAddress) String() string {
	var _arg0 *C.GInetAddress // out
	var _cret *C.gchar        // in

	_arg0 = (*C.GInetAddress)(unsafe.Pointer(externglib.InternObject(address).Native()))

	_cret = C.g_inet_address_to_string(_arg0)
	runtime.KeepAlive(address)

	var _utf8 string // out

	_utf8 = C.GoString((*C.gchar)(unsafe.Pointer(_cret)))
	defer C.free(unsafe.Pointer(_cret))

	return _utf8
}
